#pragma semicolon 1
#include <sourcemod>
#include <cstrike>
#include <colors>
#include <sdktools>
#include <sdkhooks>
#include <morecolors>
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#include "jailawards/cvars.sp"
#include "jailawards/menu.sp"
#include "jailawards/sql.sp"
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#define VERSION "1.8/FIX"

public Plugin:myinfo = 
{
	name = "Криминальный Shop",
	author = "Franc1sco & Translate LegenD =)",
	description = "Награды для Заключенных",
	version = VERSION,
	url = "http://servers-cfg.foroactivo.com/ & http://funservers.ru/"
};

public OnPluginStart() 
{
	RegConsoleCmd("say", MenuAwards);
	RegConsoleCmd("say_team", MenuAwards);
	RegConsoleCmd("say", CommandAwards);
	RegConsoleCmd("say_team", CommandAwards);
	RegConsoleCmd("sm_revive", Respawn);
	RegConsoleCmd("sm_medic", Medic);
	RegConsoleCmd("sm_датькр", GiveCredits);
	RegConsoleCmd("sm_givecr", GiveCredits);
	RegAdminCmd("sm_адмкр", AdmCredits, ADMFLAG_ROOT);
	RegAdminCmd("sm_admcr", AdmCredits, ADMFLAG_ROOT);

	// Hook's
	HookEvent("player_death", PlayerDeath);
	HookEvent("player_spawn", EventPlayerSpawn);
	HookEvent("round_end", RoundEnd);

	cvarCreditsEnable = CreateConVar("sm_system_awards_enable", "1", "Включить Систему кредитов?", FCVAR_PLUGIN, true, 0.0, true, 1.0);
	cvarCreditsMax = CreateConVar("sm_system_awards_credits_max", "100", "Макс. кредитов. (0: Нет лимита)", FCVAR_PLUGIN, true, 0.0);
	cvarCreditsKill = CreateConVar("sm_system_awards_credits_kill", "1", "Дать X кредитов за убийства", FCVAR_PLUGIN, true, 0.0);
	cvarCreditsWinCT = CreateConVar("sm_system_awards_credits_win_round_ct", "0", "Отнять X кредитов у заключенных за проигрыш в раунде", FCVAR_PLUGIN, true, 0.0);
	cvarCreditsWinT = CreateConVar("sm_system_awards_credits_win_round_t", "5", "Дать X кредитов заключенным за выйгрыш в раунде", FCVAR_PLUGIN, true, 0.0);
	cvarCreditsSave = CreateConVar("sm_system_awards_credits_save", "1", "Сохранять кредиты в SQL/MySQL базу?", FCVAR_PLUGIN, true, 0.0, true, 1.0);
	cvarCreditsGive = CreateConVar("sm_system_awards_credits_give", "1", "Разрешено ли обмениваться кредитами между игроками?", FCVAR_PLUGIN, true, 0.0, true, 1.0);
	
	// ******************************-=Цены=-**********************************
	g_PriceInv = CreateConVar("sm_price_inv", "n-1", "Стоимость Невидимости\n-1 для отключения награды");
	g_PriceSpeed = CreateConVar("sm_price_speed", "20", "Стоимость Скорость\n-1 для отключения награды");
	g_PriceGod = CreateConVar("sm_price_god", "500", "Стоимость Бессмертие\n-1 для отключения награды");
	g_PriceAwp = CreateConVar("sm_price_awp", "n-1", "Стоимость AWP\n-1 для отключения награды");
	g_PriceBird = CreateConVar("sm_price_bird", "n-1", "Стоимость Стать птицей\n-1 для отключения награды");
	g_PriceRevive = CreateConVar("sm_price_revive", "n-1", "Стоимость Возрождение(респавн)\n-1 для отключения награды");
	g_PriceUsp = CreateConVar("sm_price_usp", "200", "Стоимость USP\n-1 для отключения награды");
	g_PriceBarrelv = CreateConVar("sm_price_barrel", "n-1", "Стоимость Стать бочкой\n-1 для отключения награды");
	g_PriceAmmo = CreateConVar("sm_price_ammo", "150", "Стоимость Бесконечные патроны\n-1 для отключения награды");
	g_Price200hp = CreateConVar("sm_price_200hp", "150", "Стоимость 200 HP\n-1 для отключения награды");
	g_PriceMedic = CreateConVar("sm_price_medic", "60", "Стоимость Лечение\n-1 для отключения награды");
	g_PriceFlashbang = CreateConVar("sm_price_flashbang", "30", "Стоимость 1 Флешка\n-1 для отключения награды");
	// ************************************************************************

	cvarInterval = CreateConVar("ammo_interval", "5", "Пополнение патрон в секундах.", FCVAR_DONTRECORD, true, 1.0);
	
	clip1Offset = FindSendPropOffs("CBaseCombatWeapon", "m_iClip1");
	clip2Offset = FindSendPropOffs("CBaseCombatWeapon", "m_iClip2");

	activeOffset = FindSendPropOffs("CAI_BaseNPC", "m_hActiveWeapon");
	priAmmoTypeOffset = FindSendPropOffs("CBaseCombatWeapon", "m_iPrimaryAmmoCount");
	secAmmoTypeOffset = FindSendPropOffs("CBaseCombatWeapon", "m_iSecondaryAmmoCount");
	AutoExecConfig(true);
	
	LoadTranslations("common.phrases");

	HookConVarChange(cvarCreditsSave, OnConVarChange_CreditsSave);
}

public OnConVarChange_CreditsSave(Handle:convar, const String:oldValue[], const String:newValue[])
{
	if (convar == cvarCreditsSave)
	{
		credits_save = GetConVarBool(cvarCreditsSave);
	}
}

public OnConfigsExecuted()
{
	Connect();

	if(GetConVarInt(cvarCreditsMax) == 0)
	{
		SetConVarInt(cvarCreditsMax, 99999);
		LogMessage("Value cvar of \"Max Credits\" was 0. Value was set at 99999");
	}

	if(GetConVarInt(cvarCreditsEnable) == 1)
	{
		PluginEnabled = true;

		PrecacheModel("models/props/de_train/barrel.mdl");
		//PrecacheModel("models/pigeon.mdl");
		PrecacheModel("models/crow.mdl");

		if (AmmoTimer2 != INVALID_HANDLE)
		{
			KillTimer(AmmoTimer2);
		}

		new Float:interval = GetConVarFloat(cvarInterval);
		AmmoTimer2 = CreateTimer(interval, ResetAmmo, _, TIMER_REPEAT);
	}
	else
	{
		PluginEnabled = false;
	}
}
public OnClientPutInServer(client)
{
	SDKHook(client, SDKHook_WeaponCanUse, OnWeaponCanUse);
}

public RoundEnd(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(PluginEnabled)
	{
		new teamwin = GetEventInt(event, "winner");
		new prisonwin = GetConVarInt(cvarCreditsWinCT);
		new guardwin = GetConVarInt(cvarCreditsWinT);

		for (new players = 1; players <= MaxClients; players++)
		{
			if(teamwin == CS_TEAM_T)
			{
				if(IsClientInGame(players) && !IsFakeClient(players))
				{
					if(prisonwin > 0)
					{
						g_iCredits[players] += prisonwin;
						CPrintToChat(players, "%s Заключенные выйграли {green}%i {default}кредита за победу в этом раунде!", taga, GetConVarInt(cvarCreditsWinT));
					}
				}
			}

			if(teamwin == CS_TEAM_CT)
			{
				if(IsClientInGame(players) && !IsFakeClient(players))
				{
					if(guardwin > 0)
					{
						g_iCredits[players] -= guardwin;
						CPrintToChat(players, "%s Заключенные проиграли {green}%i {default}кредита за поражение в этом раунде!", taga, GetConVarInt(cvarCreditsWinCT));
					}
				}
			}
		}
	}
}

public Action:ReviveBuy(Handle:timer, any:client)
{
	if (IsClientInGame(client) && !IsFakeClient(client) && GetClientTeam(client) == CS_TEAM_T && !IsPlayerAlive(client))
	{
		CPrintToChat(client, "%s Умер? {green}Ебать ты лох!", taga, pricerevive);
	}
} 

public OnClientPostAdminCheck(client)
{
	g_iCredits[client] = 0;
	g_Godmode[client] = false;
	g_Fly[client] = false;
	g_AmmoInfi[client] = false;

	if(credits_save && g_SQL != INVALID_HANDLE)
	{
		if (!IsFakeClient(client) && GetClientAuthString(client, pl_steamid[client], 28))
		{
			decl String:query[125];
			Format(query, 125, "SELECT points FROM awards WHERE steamid = '%s'", pl_steamid[client]);
			SQL_TQuery(g_SQL, SQL_PostAdminCheck_CallBack, query, GetClientUserId(client));
		}
	}
}

public Action:EventPlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	
	if (GetClientTeam(client) == 1 && !IsPlayerAlive(client))
	{
		return;
	}
	
	if(PluginEnabled)
	{
		if (IsClientInGame(client) && GetClientTeam(client) == CS_TEAM_T && IsPlayerAlive(client))
		{
			CPrintToChat(client, "%s{lightgreen}Убивай Охранников, чтобы получать кредиты!", taga);
			CPrintToChat(client, "%s{lightgreen}Введи в чат {green}!shop {lightgreen}, чтобы открыть меню с {red}Криминального шопа!", taga);

			SetEntityRenderColor(client, 255, 255, 255, 255);
			new knife = GetPlayerWeaponSlot(client, 2); 
			if(IsValidEntity(knife)) 
			{ 
				SetEntityRenderColor(knife, 255,255,255,255); 
			}
		}
	}

	if (g_Fly[client])
	{
		g_Fly[client] = false;
		SetEntityMoveType(client, MOVETYPE_WALK);
	}

	if (g_Godmode[client])
	{
		g_Godmode[client] = false;
	}

	if (g_AmmoInfi[client])
	{
		g_AmmoInfi[client] = false;
	}
}

public Action:PlayerDeath(Handle:event, const String:name[], bool:dontBroadcast) 
{
	new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	
	if(!IsClientInGame(client))
	{
		return Plugin_Handled;
	}

	if(pricerevive != -1)
		CreateTimer(2.0, ReviveBuy, client);
    
	if (!attacker)
		return Plugin_Handled;

	if (attacker == client)
		return Plugin_Handled;

	if(GetClientTeam(attacker) == CS_TEAM_T)
	{
		g_iCredits[attacker] += GetConVarInt(cvarCreditsKill);

		if (g_iCredits[attacker] < GetConVarInt(cvarCreditsMax))
		{
			CPrintToChat(attacker, "%s У тебя: {green}%i {default}кредитов {lightgreen}(+%i)", taga, g_iCredits[attacker], GetConVarInt(cvarCreditsKill));
		}
		else
		{
			g_iCredits[attacker] = GetConVarInt(cvarCreditsMax);
			CPrintToChat(attacker, "%s У тебя: {green}%i {default}кредитов {lightgreen}(Максимум)", taga, g_iCredits[attacker]);
		}
	}

	return Plugin_Handled;
}

public Action:GiveCredits(client, args)
{
	if(PluginEnabled || GetConVarInt(cvarCreditsGive) == 1)
	{
		if(args < 2) 
		{
			CPrintToChat(client, "%s Использование: {lightgreen}!датькр \"ник\" \"кол-во кредитов\"", taga);
			return Plugin_Handled;
		}

		new String:targetName[MAX_NAME_LENGTH];
		GetCmdArg(1, targetName, sizeof(targetName));

		new target = FindTarget(client, targetName, true);
		
		new String:amount[32];
		GetCmdArg(2, amount, sizeof(amount));
		new amountc = StringToInt(amount);

		if(GetClientTeam(client) == CS_TEAM_T)
		{
			if (g_iCredits[client] >= amountc)
			{
				if(IsClientValid(target) && GetClientTeam(target) == CS_TEAM_T)
				{
					if(client != target)
					{
						UpdateCrd(client, amountc);
						UpdateCrd(client, amountc, false);
						CPrintToChat(target, "%s {green}%N{default} отправил Вам {green}%i{default} кредитов. Теперь у Вас {green}%i{default} кредитов.", taga, client, amountc, g_iCredits[target]);
						CPrintToChat(client, "%s Вы передали {green}%i{default} кредитов игроку {green}%N{lightgreen}(-%i кредитов)", taga, amountc, target, amountc);
					}
					else
					{
						CPrintToChat(client, "%s Нельзя передавать кредиты самому себе!", taga);
					}
				}
				else
				{
					CPrintToChat(client, "%s Игрок не в игре или он из команды Охраны!", taga);
				}
			}
			else
			{
				CPrintToChat(client, "%s Вы пытаетесь отправить {green}%i{default} кредитов, когда у Вас только {green}%i{default}!", taga, amountc, g_iCredits[client]);
			}
		}
		else
		{
			CPrintToChat(client, "%s Вы не заключенный!", taga);
		}
	}
	else
	{
		CPrintToChat(client, "%s В данный момент эта возможность отключена.", taga);
	}
	return Plugin_Handled;
}
stock IsClientValid(client) 
{ 
    if (client <= 0 || client > MaxClients) 
    { 
        client = GetClientFromSerial(client); 
    } 

    return client > 0 && client <= MaxClients && IsClientConnected(client) && IsClientInGame(client); 
}  

public Action:Option16b(Handle:timer, any:client)
{
	if ((IsClientInGame(client)) && (IsPlayerAlive(client)) && GetClientTeam(client) == CS_TEAM_T)
	{
		SetEntProp(client, Prop_Data, "m_takedamage", 2);
		g_Godmode[client] = false;
		CPrintToChat(client, "%s Ты стал смертным!", taga);
		//CreateTimer(10.0, Option16c, client);
	}
}

public Action:Option16c(Handle:timer, any:client)
{
	if ((IsClientInGame(client)) && (IsPlayerAlive(client)))
	{
		CPrintToChat(client, "%s Ты стал видимым!", taga);
		SetEntityRenderColor(client, 255, 255, 255, 255);

		new knife = GetPlayerWeaponSlot(client, 2); 

		if(IsValidEntity(knife)) 
		{ 
			SetEntityRenderColor(knife, 255,255,255,255); 
		}
	}
}

public Action:OnWeaponCanUse(client, weapon)
{
	if (g_Fly[client])
	{
		decl String:sClassname[32];
		GetEdictClassname(weapon, sClassname, sizeof(sClassname));
		if (!StrEqual(sClassname, "weapon_knife"))
			return Plugin_Handled;
	}
	return Plugin_Continue;
}

public Action:ResetAmmo(Handle:timer)
{
	for (new client = 1; client <= MaxClients; client++)
	{
		if (IsClientConnected(client) && !IsFakeClient(client) && IsClientInGame(client) && IsPlayerAlive(client) && (g_AmmoInfi[client]) && GetClientTeam(client) == CS_TEAM_T)
		{
			Client_ResetAmmo(client);
		}
	}
}

public Client_ResetAmmo(client)
{
	new zomg = GetEntDataEnt2(client, activeOffset);
	if (clip1Offset != -1 && zomg != -1)
		SetEntData(zomg, clip1Offset, 200, 4, true);
	if (clip2Offset != -1 && zomg != -1)
		SetEntData(zomg, clip2Offset, 200, 4, true);
	if (priAmmoTypeOffset != -1 && zomg != -1)
		SetEntData(zomg, priAmmoTypeOffset, 200, 4, true);
	if (secAmmoTypeOffset != -1 && zomg != -1)
		SetEntData(zomg, secAmmoTypeOffset, 200, 4, true);
}

public Action:CommandAwards(client, args)
{
	decl String:Said[128];
	GetCmdArgString(Said, sizeof(Said)-1);
	StripQuotes(Said);
	TrimString(Said);
	
	if(StrEqual(Said, "!кр") || StrEqual(Said, "!кредиты"))
	{
		if(PluginEnabled)
		{
			if (!IsFakeClient(client) && IsClientInGame(client) && GetClientTeam(client) == CS_TEAM_T)
			{
				CPrintToChat(client, "%s У тебя: {green}%i {default}кредитов", taga, g_iCredits[client]);
			}
			else
			{
				CPrintToChat(client, "%s Вы не заключенный!", taga);
			}
		}
		else
		{
			CPrintToChat(client, "%s Награды отключены!", taga);
		}

		return Plugin_Handled;
	}
	return Plugin_Continue;
}

public Action:Respawn(client,args)
{
	if(PluginEnabled)
	{
		if(GetClientTeam(client) == CS_TEAM_T)
		{
			if (!IsPlayerAlive(client))
			{
				if (g_iCredits[client] >= pricerevive)
				{
					CS_RespawnPlayer(client);

					UpdateCrd(client, pricerevive);

					CPrintToChatAll("%s Игрок {green}%N{default} возродился!", taga, client);
				}
				else
				{
					CPrintToChat(client, "%s У тебя: {green}%i {default}кредитов {lightgreen}(Не хватает кредитов! Нужно %i!)", taga, g_iCredits[client], pricerevive);
				}
			}
			else
			{
				CPrintToChat(client, "%s Вы должны быть мертвы!", taga);
			}
		}
		else
		{
			CPrintToChat(client, "%s Вы не заключенный!", taga);
		}
	}
	else
	{
		CPrintToChat(client, "%s Награды отключены!", taga);
	}

	return Plugin_Handled;
}

public Action:Medic(client,args)
{
	if(PluginEnabled)
	{
		if(GetClientTeam(client) == CS_TEAM_T)
		{
			if (IsPlayerAlive(client))
			{
				if (g_iCredits[client] >= pricemedic)
				{
					SetEntityHealth(client, 100);

					UpdateCrd(client, pricemedic);

					CPrintToChatAll("%s Игрок{green}%N {default}был вылечен!", taga, client);

					CPrintToChat(client, "%s Ты вылечен. У тебя: {green}%i {default}кредитов {lightgreen}(-%i)", taga, g_iCredits[client], pricemedic);

				}
				else
				{
					CPrintToChat(client, "%s У тебя: {green}%i{default} кредитов {lightgreen}(Не хватает кредитов! Нужно %i)", taga, g_iCredits[client], pricemedic);
				}
			}
			else
			{
				CPrintToChat(client, "%s Вы мертвы!", taga);
			}
		}
		else
		{
			CPrintToChat(client, "%s Вы не заключенный!", taga);
		}
	}
	else
	{
		CPrintToChat(client, "%s Награды отключены!", taga);
	}

	return Plugin_Handled;
}


public Action:AdmCredits(client, args)
{
	if(PluginEnabled)
	{
		if(args < 2)
		{
			CPrintToChat(client, "%s Использование: {lightgreen}!адмкр \"ник\" \"кол-во кредитов\"", taga);
			return Plugin_Handled;
		}

		new String:targetName[MAX_NAME_LENGTH];
		GetCmdArg(1, targetName, sizeof(targetName));

		new target = FindTarget(client, targetName, true);

		new String:amount[32];
		GetCmdArg(2, amount, sizeof(amount));
		new amountc = StringToInt(amount);

		if(IsClientInGame(target) && !IsFakeClient(target))
		{
			if(g_iCredits[target] >= GetConVarInt(cvarCreditsMax))
			{
				g_iCredits[target] = GetConVarInt(cvarCreditsMax);
				CPrintToChat(client, "%s У {green}%N{default} уже больше {green}%i{default} кредитов!", taga, target, GetConVarInt(cvarCreditsMax));
			}
			else
			{
				CPrintToChat(client, "%s Вы передали {green}%i{default} кредитов игроку {green}%N", taga, amountc, target);
				CPrintToChat(target, "%s {green}%N{default} отправил Вам {green}%i{default} кредитов.", taga, client, amountc);
				g_iCredits[target] += amountc;
			}
		}
		else
		{
			CPrintToChat(client, "%s Игрок не найден!", taga);
		}
	}
	else
	{
		CPrintToChat(client, "%s Награды отключены!", taga);
	}

	return Plugin_Handled;
}

public OnClientDisconnect(client)
{
	if(credits_save && g_SQL != INVALID_HANDLE)
	{
		if (!IsFakeClient(client))
		{
			decl String:query[125];
			Format(query, 125, "UPDATE awards SET points = %d WHERE steamid = '%s'", g_iCredits[client], pl_steamid[client]);
			SQL_TQuery(g_SQL, SQL_PluginCallback, query, 0);
		}
	}
}

UpdateCrd(client, sum, bool:minus = true) 
{
	if(minus)
	{
		g_iCredits[client] -= sum;
	}
	else
	{
		g_iCredits[client] += sum;
	}
}